/* QEENS.C, Version 1.0, Sun Apr  7 18:47:29 MET DST 1996 

  

   Written by Christian Pluym, email: nirmal@fly.cc.fer.hr

   A program that solves the 8 queens problem - ALL 92 solutions.

   May be also used as a speed benchmark of your computer/compiler 

   On a AMD 486DX2-66 compiled with bcc 4.5 it was done in 147 seconds.

   Compiled with 'gcc -O2' and ran with 'nice -20 a.out' it was done in

   121 seconds. Please fill out this form and send it to me. The results

   will be posted on http://fly.cc.fer.hr/~nirmal

 

 --- CUT HERE ---



TESTER: (Christian Pluym, nirmal@fly.cc.fer.hr)

CPU: (AMD 486DX2-66)

OS: (Linux 1.2.13)

COMPILER: (gcc)

VERSION: (2.7.2)

COMPILING OPTIONS: (-O2)

RESULT: (121 seconds)



--- CUT HERE ---

 

  If you are running it on a *NIX box make sure to run it with minimum

  niceness.

 

 */



#include <stdio.h>

#include <time.h>



int tuku_se(void);

void ispisi(void);



static int ploca[8][8], a,b,c,d,e,f,g,h, br;



int main(void)

{

	time_t t;



	t=time(NULL);

	for(a=0;a<8;a++)

	{

	 ploca[0][a]=1;

	 for(b=0;b<8;b++)

	 {

	  ploca[1][b]=1;

	  for(c=0;c<8;c++)

	  {

		ploca[2][c]=1;

		for(d=0;d<8;d++)

		{

		 ploca[3][d]=1;

		for(e=0;e<8;e++)

		{

		 ploca[4][e]=1;

		 for(f=0;f<8;f++)

		 {

		  ploca[5][f]=1;

		  for(g=0;g<8;g++)

		  {

			ploca[6][g]=1;

			for(h=0;h<8;h++)

			{

			 ploca[7][h]=1;

			 if(!tuku_se()) {br++; ispisi();}

			 ploca[7][h]=0;

			}

			ploca[6][g]=0;}

		  ploca[5][f]=0;}

		 ploca[4][e]=0;}

		ploca[3][d]=0;}

	  ploca[2][c]=0;}

	 ploca[1][b]=0;}

	ploca[0][a]=0;}

	printf("Finished in %ld seconds\n",time(NULL)-t);

	return(0);

}



int tuku_se(void)

{

	int i, j, red, dijag11, dijag12, dijag21, dijag22;

	for(i=0;i<8;i++)

	{

		red=0;

		for(j=0;j<8;j++)

			red+=ploca[j][i];

		if(red>1) return(-1);

	}

	for(i=0;i<8;i++)

	{

		dijag11=dijag12=dijag21=dijag22=0;

		for(j=0;j<=i;j++)

		{

			dijag11+=ploca[j][i-j];

			dijag21+=ploca[7-(i-j)][j];

			dijag12+=ploca[7-(i-j)][7-j];

			dijag22+=ploca[j][7-(i-j)];

		}

		if(i!=0)

			if((dijag11>1)||(dijag12>1)||(dijag21>1)||(dijag22>1)) return(-1);

	}

	return(0);

}



void ispisi(void)

{

	int x,y;

	printf("%d\n",br);

	for (y=0;y<8;y++)

	{

		for(x=0;x<8;x++)

		{

			if(ploca[x][y]==1) printf("  x");

			else printf("  -");

		}

	printf("\n");

	}

	printf("\n\n");

}

